####P#################################
##Any Queries about this code email
## pauljwilson@wlv.ac.uk




#library(gamlss)
#library(poibin)
#library(VGAM)
#rm(list=ls())
n2<-1000000
op<-function(t) ifelse(t<=0.5,0.5,(1+t)/2)
n<-100## sample size
nn<-500 ## number of resamples per mu

####Martin Ridout's function####
h1<-function(t)  t*(1-exp(1/t-t))
h2a<-function(t)  t*(1-exp(-h1(t)))^2-(h1(t))^2*exp(-h1(t))
h2b<-function(t)  1-(h1(t)+1)*(exp(-h1(t)))

h2<-function(t)   h2a(t)/h2b(t)
###################################################

f<-function(t)  ifelse(t<2.07,0.7*(0.85^t),0.5)

alpha<-0.05



ZI<-seq(-0.15,0.8,0.05)
LQ<-length(ZI)

v<-0.8
par(mfrow=c(1,1))

ALLR<-LLLR<-AS<-CCETFINAL2<-CCETFINAL<-CCETTWOSTAGEa<-CCETTWOSTAGE<-CCET<-rep(888,LQ)#Not all of these are needed

for(q in 1:length(ZI)){
LLR1<-LLR<-OLLR<- LLR<- S<-CETFINAL2<-CETFINAL<-CETP<-CETTWOSTAGEa<-CETTWOSTAGE<-CETTWOSTAGE2<-CETTWOSTAGEa2<-rep(999,nn)
  zi<-ZI[q]
print(zi)

for(j in 1:nn){

  
  X<-rep(999,n)
w<-runif(n,0.5,1)+0.5
for(i in 1:n){
  p<-zi
myzip22<-function(y) ifelse(y==0, p+(1-p)*dpois(y,w[i]), (1-p)*dpois(y,w[i]))

aa<-rep(0:20,myzip22(0:20)*n2)
X[i]<-sample(aa,1)
}
n0<-XO<-length(X[X==0])
y<-X[X>0]
w1<-w[X>0]

#modp<-glm(X~w,family=poisson(link=identity),start=c(1,1))
#don't think the above works right for LLp later on?

mypois<-function(a,b,y) dpois(y,a+b*w)


fun1 = function(x, y) sum(log(mypois(x[1], x[2], y)))

estpois = optim(c(1,1),fun1,control=list(fnscale=-1),y=X,hessian=T)

modt<-vglm(y~w1,family=pospoisson(link=identitylink),start=c(1,1))

myzip2<-function(p,a,b,y) ifelse(y==0, p+(1-p)*dpois(y,a+b*w), (1-p)*dpois(y,a+b*w))


fun2 = function(x, y) sum(log(myzip2(x[1], x[2],x[3], y)))

est = optim(c(0.2,1,1),fun2,control=list(fnscale=-1),y=X,hessian=T)
########################################

DM<-as.matrix(data.frame(1,w))
cf<-coefficients(modt)

muw<-DM%*%estpois$par
mut<-DM%*%cf

h<-f(muw)  ## this is the parametric mixer
mum<-h*muw+(1-h)*(mut)


#LLp<- logLik(modp)
LLp<-estpois$value
LLz<- est$value

LLR[j]<- -2*(LLp-LLz)


OLLR[j]<-max((LLR[j]),0) ##this is not really needed!
##########################################################################################
mfv<-dpois(0,mum)


###############for parametric  a #######################
p1<-ppoibin(XO, mfv)
XO1<-qpoibin(1-p1, mfv)
p2<-ppoibin(XO-1, mfv)
XO2<-qpoibin(1-p2, mfv)

maxx<-max(XO,XO1)
minn<-min(XO,XO1)


maxx2<-max(XO-1,XO2)
minn2<-min(XO-1,XO2)


CETTWOSTAGE[j]<-1-ppoibin(maxx,mfv)##the p-value of the Chistmas Eve Test

CETTWOSTAGEa[j]<-1-ppoibin(maxx2,mfv)##the p-value of the Chistmas Eve Test


CETFINAL[j]<-2*(CETTWOSTAGE[j]*1/2+CETTWOSTAGEa[j]*1/2)##the p-value of the Chistmas Eve Test#
###further work needs to be done re the most appropriate way of determining the two-sided p-value###
#########################################################################



}


CCETFINAL[q]<-length(CETFINAL[CETFINAL<alpha])/nn

LQ<-q

LLLR1<-(1-(pchisq(OLLR,1)))

LLLR[q]<-  length(LLLR1[LLLR1<alpha])/length(LLLR1)
plot(ZI[1:LQ],CCETFINAL[1:LQ],type="l",pch=4,col="grey5",cex=0.6,lty="dotted",lwd=2,ylim=c(0,1), xlim=c(-0.2,1),ylab="",xlab="Zero-Inflation  Parameter", main="POWER, mu=1.0, n=30 \n One-Sided")
par(new=TRUE)
plot(ZI[1:LQ],LLLR[1:LQ],col="grey10", type="l",pch=19,lty="solid",lwd=2,cex=0.6,ylim=c(0,1), xlim=c(-0.2,1),ylab="",xlab=" ",main=" ")

abline(h=0.05,lty="dotted",lwd=1)

abline(h=0.8,lty="dotted")
abline(v=0.0,lty="dotted")

}

plot(ZI[1:LQ],CCETFINAL[1:LQ],type="l",pch=4,col="grey5",cex=0.6,lty="dotted",lwd=2,ylim=c(0,1), xlim=c(-0.2,1),ylab="",xlab=expression(omega), main="n=100  Two Sided")
par(new=TRUE)
plot(ZI[1:LQ],LLLR[1:LQ],col="grey10", type="l",pch=19,lty="solid",lwd=2,cex=0.6,ylim=c(0,1), xlim=c(-0.2,1),ylab="",xlab=" ",main=" ")


abline(h=0.05,lty="dotted",lwd=1)

abline(h=0.8,lty="dotted")
abline(v=0.0,lty="dotted")

leg.names<-c("adaptive",   "LR test")
legend("bottomright", leg.names, lty=c("dotted","solid") , lwd=c(2,2),col=c("grey5","grey15"), cex=1.2)

