### This is the code for figure 2 right of the   Wilson-Einbeck
rm(list=ls())
nn<-25000
library(poibin)
n<-500 

h1<-function(t)  t*(1-exp(1/t-t))
h2a<-function(t)  t*(1-exp(-h1(t)))^2-(h1(t))^2*exp(-h1(t))
h2b<-function(t)  1-(h1(t)+1)*(exp(-h1(t)))

h2<-function(t)   h2a(t)/h2b(t)

#########h2 is Martin Ridout's approximation to h^{-1}(\hat\zeta)####

f<-function(t)  ifelse(t<2.07,0.7*(0.85^t),0.5) ## the parametric mixer

alpha<-0.05 ## level of significance

MU<-seq(0.5,4.5,0.5)
LQ<-length(MU)

CCETFINAL<-CCETFINALfix<-CCETTWOSTAGEafix<-CCETTWOSTAGEfix<-AS<-CCETFINAL2<-CCETFINAL<-CCETTWOSTAGEa<-CCETTWOSTAGE<-CCET<-rep(888,LQ)


for(q in 1:length(MU)){

 CETFINALfix<-CETTWOSTAGEafix<-CETTWOSTAGEfix<-CETFINAL2<-CETFINAL<-CETP<-CETTWOSTAGEa<-CETTWOSTAGE<-rep(999,nn)


mu<-MU[q]

print(mu)


for(j in 1:nn){



X<-rpois(n,mu)
y<-X[X>0]
XO<-length(X[X==0])

############################FIXED#################

mumfix<-h2(mean(y))
p1<-dpois(0,mumfix)


ff1<-function(t) pbinom(t,size=n,prob=p1)-0.5*dbinom(t,size=n,prob=p1)
ff2<-function(t) ifelse(ff1(t)>0.5,1-ff1(t),ff1(t))

ff<-function(t)  2*ff2(t)

CETFINALfix[j]<-ff(XO)

}


CCETFINALfix[q]<-length(CETFINALfix[CETFINALfix<alpha])/nn
abline(h=alpha,lty="dotted")
}

plot(MU,CCETFINALfix,type="l",pch=4,col="grey5",cex=1.1,cex.lab=1.5, cex.main=1.5, lty="dashed",lwd=2,ylim=c(0,0.4), xlim=c(0,4.5),ylab="",xlab=paste(expression(mu),"=","Truncated Sample Estimate"),main="n=500  Two Sided",cex.lab=1.4)

abline(h=alpha,lty="dotted")

