#library(gamlss)
#library(poibin)
#library(VGAM)
n<-100

rm(a)
h1<-function(t)  t*(1-exp(1/t-t))
h2a<-function(t)  t*(1-exp(-h1(t)))^2-(h1(t))^2*exp(-h1(t))
h2b<-function(t)  1-(h1(t)+1)*(exp(-h1(t)))

h2<-function(t)   h2a(t)/h2b(t)

I<-function(t) ifelse(t==0,0,1)

f<-function(t)  ifelse(t<2.07,0.7*(0.85^t),0.5)

alpha<-0.05
nn<-5000

Y<-rep(999,n)
############

x1<-runif(n,0,0.5)
x2<-runif(n,0,0.5)
w1<-runif(n,1,2)

X<-x1+x2+0.1


zmin<-  max(-1/(exp(X)-1))+0.01


ZI<-c(0.00000000000000000000000000001, 0.0332, seq(0.05,0.85,0.05))
LQ<-length(ZI)
xx<-0
v<-0.8
par(mfrow=c(1,1))


LLR<-CCETFINAL2<-CCETFINAL<-CCETTWOSTAGEa<-CCETTWOSTAGE<-CCET<-rep(888,LQ)

#MU<-seq(0.5,6,0.5)
for(q in 1:length(ZI)){
LR<-CETFINAL2<-CETFINAL<-CETP<-CETTWOSTAGEa<-CETTWOSTAGE<-rep(999,nn)


zi<-ZI[q]
print(zi)

x1<-runif(n,0.2,1)
x2<-runif(n,0.2,1)



XX<-cbind(1,x1,x2)
MU<-x1+x2+0.1
kk<-length(CETTWOSTAGE[CETTWOSTAGE<99])
kk<-1
for(j in kk:nn){
print(c(zi,j))

Y<-rZIP(n, mu=MU,sigma=zi)
  
XO<-n0<-length(Y[Y==0])
#print(c(mu,n,n0))

y<-Y[Y>0]

#mt<-mean(y)
#muw<-mean(X)

modp<-glm(Y~x1+x2,family="poisson")



muw<-modp$fitted.values



#x1a<-x1[Y>0]
#x2a<-x2[Y>0]
x1a<-x1[Y>0]
x2a<-x2[Y>0]
#x3a<-x3[Y>0]
m1 <- vglm(y~x1a+x2a, family = pospoisson())
cm1<-coefficients(m1)
mut<-exp(XX%*%cm1)

a<-f(muw)
mum<-a*muw+(1-a)*(mut)
###check if we need h2, we don't


p0<- exp(-muw)


mfv<-dpois(xx,mum)
CETTWOSTAGE[j]<-1-ppoibin(XO,mfv)##the p-value of the Chistmas Eve Test
CETTWOSTAGEa[j]<-1-ppoibin(XO-1,mfv)##the p-value of the Chistmas Eve Test

CETFINAL[j]<-CETTWOSTAGE[j]*1/2+CETTWOSTAGEa[j]*1/2##the p-value of the Chistmas Eve Test

#######################################LR######################################
modz<-gamlss(Y~x1+x2,sigma.fo=~1,family="ZIP",trace=FALSE)

LR[j]<-1-pchisq( -2*(logLik(modp)-logLik(modz)),1)


}
#print(Y)


CCETFINAL[q]<-length(CETFINAL[CETFINAL<alpha])/nn
LLR[q]<-length(LR[LR<alpha])/nn



LQ<-q
plot(ZI[1:LQ],CCETFINAL[1:LQ],type="l",pch=4,col="grey2",cex=0.5,lty="dotted",lwd=3,ylim=c(0,1), xlim=c(0,1),ylab="",xlab=expression(omega),main=expression(atop("n=100  One Sided", mu~"~"~w[1]~"+" ~w[2]~"+0.1")),cex.lab=1.4)
par(new=TRUE)
plot(ZI[1:LQ],LLR[1:LQ],lty="solid",col="grey3",type="l",pch=4,lwd=3,cex=0.5,ylim=c(0,1), xlim=c(0,1),ylab="",xlab=" ",main=" ")

abline(h=0.8,lty="dotted",lwd=2)

abline(h=alpha,lty="dotted")
}




#############################################################################
#############################################################################
